//	*******************************************************************************
//	Name	:	bracket.hxx
//			:	Bracket Functions
//	Author	:	I. Nakagawa
//	Create	:	2016/11/30
//	Modify	:	2016/11/30
//	Modify	:	2024/11/27
//	*******************************************************************************

#pragma		once

//#include	"tstring.hxx"
//#include	"stringfn.hxx"
#include	"strary_f.hxx"
#include	"v_tstrng.hxx"

////
//	*******************************************************************************
//	Is Enclosed ?
//	Create	:	2016/11/30
//	*******************************************************************************
inline	bool	Bracket_IsEnclosed	(c_tstring& str)
{
	bool	isBrkt = false ;
	if (str.length() < 2)						{	return	isBrkt ;	}
	TCHAR	cl = str[0] ;
	TCHAR	cr = ::String_GetLast_TC(str) ;
	{
		if (cl == _T('(') && cr == _T(')'))		{	isBrkt = true ;		}
		if (cl == _T('<') && cr == _T('>'))		{	isBrkt = true ;		}
		if (cl == _T('[') && cr == _T(']'))		{	isBrkt = true ;		}
		if (cl == _T('{') && cr == _T('}'))		{	isBrkt = true ;		}
		}
	return	isBrkt ;
	}

////
//	*******************************************************************************
//	Add Bracket
//	Create	:	2016/11/30
//	*******************************************************************************
inline	tstring	Bracket_Add	(c_tstring& str,const TCHAR q=_T('('))
{
	TCHAR	ql = q ;
	TCHAR	qr = q ;
	if (ql == _T('('))		{	qr = _T(')') ;	}
	if (ql == _T('<'))		{	qr = _T('>') ;	}
	if (ql == _T('['))		{	qr = _T(']') ;	}
	if (ql == _T('{'))		{	qr = _T('}') ;	}
	return	ql+str+qr ;
	}

////
//	*******************************************************************************
//	Delete Bracket
//	Create	:	2016/11/30
//	*******************************************************************************
inline	tstring	Bracket_Del	(c_tstring& str)
{
	if (!::Bracket_IsEnclosed(str))		{	return	str ;	}
	return	str.substr(1,str.length()-2) ;
	}

////
//	*******************************************************************************
//	Add Auto
//	Create	:	2016/11/30
//	*******************************************************************************
/*
inline	tstring	Bracket_Add_Auto	(c_tstring& str)
{
	bool	needQuot = false ;
	if		(str.find(_T(','))	!= tstring::npos)	{	needQuot = true ;	}
	else if	(str.find(_T('\t')) != tstring::npos)	{	needQuot = true ;	}
	else if	(str.find(_T(' '))	!= tstring::npos)	{	needQuot = true ;	}
	else if	(str.find(_T('\r'))	!= tstring::npos)	{	needQuot = true ;	}
	else if	(str.find(_T('\n'))	!= tstring::npos)	{	needQuot = true ;	}
	else											{	return	str ;		}
	if		(::Bracket_IsEnclosed(str))				{	return	str ;		}
	return	::Bracket_Add(str) ;
	}
*/

////
//	*******************************************************************************
//	Delete All
//	Create	:	2016/11/30
//	*******************************************************************************
inline	tstring	Bracket_Del_All	(c_tstring& str_)
{
	tstring	str = str_ ;
	if (str.empty())					{	return	str ;	}
	for (size_t index=0 ; index<str.length() ; index++) {
		if (!::Bracket_IsEnclosed(str))	{	return	str ;	}
		str = ::Bracket_Del(str) ;
		}
	return	str ;
	}

////
//	*******************************************************************************
//	LPCTSTR type Functions
//	Create	:	2016/11/30
//	*******************************************************************************
	inline	tstring	Bracket_Add		(LPCTSTR str,const TCHAR q=_T('('))		{	return	Bracket_Add		(tstring(str), q) ;		}
	inline	tstring	Bracket_Del		(LPCTSTR str)							{	return	Bracket_Del		(tstring(str)	) ;		}
//	inline	tstring	Bracket_Add_Auto(LPCTSTR str)							{	return	Bracket_Add_Auto(tstring(str)	) ;		}
	inline	tstring	Bracket_Del_All	(LPCTSTR str)							{	return	Bracket_Del_All	(tstring(str)	) ;		}

////
//	*******************************************************************************
//	Add 
//	Create	:	2016/11/30
//	*******************************************************************************
inline	v_tstring	Bracket_Add		(c_v_tstring& strAry)
{
	v_tstring	add_sa ;
	for (size_t index=0 ; index<strAry.size() ; index++) {
		tstring	str = strAry[index] ;
				str = ::Bracket_Add(str) ;
		add_sa.push_back(str) ;
		}
	return	add_sa ;
	}

////
//	*******************************************************************************
//	Add Auto
//	Create	:	2016/11/30
//	*******************************************************************************
/*
inline	v_tstring	Bracket_Add_Auto	(c_v_tstring& strAry)
{
	v_tstring	add_sa ;
	for (size_t index=0 ; index<strAry.size() ; index++) {
		tstring	str = strAry[index] ;
				str = ::Bracket_Add_Auto(str) ;
		add_sa.push_back(str) ;
		}
	return	add_sa ;
	}
*/

////
//	*******************************************************************************
//	Delete All
//	Create	:	2016/11/30
//	*******************************************************************************
inline	v_tstring	Bracket_Del_All	(c_v_tstring& strAry)
{
	v_tstring	del_sa ;
	for (size_t index=0 ; index<strAry.size() ; index++) {
		tstring	str = strAry[index] ;
				str = ::Bracket_Del_All(str) ;
		del_sa.push_back(str) ;
		}
	return	del_sa ;
	}

