//	*******************************************************************************
//	Name	:	createff.hxx
//			:	Create folder , Create empty file
//	Author	:	I. Nakagawa
//	Create	:	2013/08/30
//	Modify	:	2013/08/30
//	Modify	:	2019/12/18	add	::CreateUniqueEmpty
//			:	2024/11/20
//	*******************************************************************************

#pragma		once

#include	<fcntl.h>
#ifdef		_MSC_VER
	#include	<direct.h>
	#include	<io.h>
#else
#endif
#ifdef		__GNUC__
	#include	<unistd.h>
	#include	"gn_mkdir.hxx"
	#define		_tmkdir		MakeDir
#endif

#include	"existff.hxx"
#include	"filepath.hxx"
#include	"i_debug.hxx"
#include	"t_tstrng.hxx"

//#include	"straryfn.hxx"
//#include	"log_msg.hxx"

#ifdef		__GNUC__
#ifndef		_close
#define		_close		close
#endif
#endif

////
//	*******************************************************************************
//	Create folder
//	Create	:	2013/08/30
//	*******************************************************************************
inline	bool	Folder_Create	(const tstring& folderName)
{
	if (::Folder_IsExist(folderName.c_str()))	{	return	true ;		}
	tstring	foldName = folderName ;
	{	//	Folder1/Folder2\Folder3		->		Folder1\\Folder2\\Folder3	/	Folder1/Folder2/Folder3
	//	v_tstring	fold_Ary ;
	//	fold_Ary = ::String_Split	(foldName,Path_SP_Win) ;
	//	foldName = ::String_Join	(fold_Ary,Path_SP) ;
	//	fold_Ary = ::String_Split	(foldName,Path_SP_GNU) ;
	//	foldName = ::String_Join	(fold_Ary,Path_SP) ;
		foldName = ::Path_Normalize	(foldName) ;
		foldName = ::Path_DelLastSP	(foldName) ;
		}
	v_tstring	foldAry = ::String_Split(foldName,Path_SP) ;
	{
		tstring	checkFolder ;
		for (size_t index=0 ; index<foldAry.size() ; index++) {
			if (index > 0)	{	checkFolder += Path_SP ;	}
			checkFolder += foldAry[index] ;
			if (checkFolder.empty())							{	continue ;		}
			if (checkFolder == _T("/"))							{	continue ;		}
			if (checkFolder == _T("\\"))						{	continue ;		}
			if (::Folder_IsExist(checkFolder.c_str()))			{	continue ;		}
		//	if (checkFolder.Right(1) == _T(":"))				{	continue ;		}
			if (::String_GetLast_TC(checkFolder) == _T(':'))	{	continue ;		}
			if (checkFolder.substr(0,2) == _T("\\\\")) {	//	only Windows
				tstring	uncPath = checkFolder.substr(2) ;
				tstring::size_type	spIndex = uncPath.find(_T('\\')) ;
				if (spIndex == tstring::npos)					{	continue ;		}
				tstring	uncFold = uncPath.substr(spIndex+1) ;
				if (uncFold.find(_T("\\")) == tstring::npos)	{	continue ;		}
				}
			if (checkFolder.substr(0,2) == _T("//")) {
				tstring	uncPath = checkFolder.substr(2) ;
				tstring::size_type	spIndex = uncPath.find(_T("/")) ;
				if (spIndex == tstring::npos)					{	continue ;		}
				tstring	uncFold = uncPath.substr(spIndex+1) ;
				if (uncFold.find(_T("/")) == tstring::npos)		{	continue ;		}
				}
			if (::_tmkdir(checkFolder.c_str()) == 0)			{	continue ;		}
		//	::Log_Message((_T("Can't create ")+checkFolder).c_str()) ;
			::i_Dump     ((_T("Can't create ")+checkFolder).c_str()) ;
			return	false ;
			break ;
			}
		}
	return	true ;
	}

////
//	*******************************************************************************
//	Create empty file
//	Create	:	2013/08/30
//	Modify	:	2017/03/03	add check "Folder_Create"
//	*******************************************************************************
inline	bool	File_CreateEmpty	(const tstring& fileName_)
{
	tstring	fileName = ::Path_Normalize	(fileName_) ;
	//	Check Folder
	tstring	foldName = ::Path_GetDir(fileName.c_str()) ;
	if (::Folder_IsNothing(foldName)) {
		if (!::Folder_Create(foldName)) {
			return	false ;
			}
		}
	{
		int	mode = S_IREAD | S_IWRITE ;
		int	fh = ::TCreat(fileName,mode) ;
		if (fh == -1)	{	::i_Dump(errno) ;		return	false ;		}
		::_close(fh) ;
		}
	return	true ;
	}

////
//	*******************************************************************************
//	create unique file
//	Create	:	2019/12/17
//	*******************************************************************************
inline	tstring	CreateUniqueEmpty	(LPCTSTR file_name_)
{
	tstring	file_name = file_name_ ;
	{
		long	count = 0 ;
		if (::File_IsExist(file_name))	{
			tstring	base = ::Path_GetBase(file_name_) ;
			tstring	ext  = ::Path_GetExt (file_name_) ;
			for (int index=0 ; index<1000 ; index++) {
				file_name = base + _T(".") + ::To_tstring(count) + _T(".") + ext ;
				if (::File_IsExist(file_name))	{
					count++ ;
					}
				else {
					break ;
					}
				}
			}
		}
	::File_CreateEmpty(file_name) ;
	return	file_name ;
	}

