//	*******************************************************************************
//	Name	:	debug_cc.hxx
//			:	Debug Compile Macro Functions
//	Author	:	I. Nakagawa
//	Create	:	2024/11/12
//	*******************************************************************************

#pragma		once

#include	"xtot.hxx"
#include	"str_join.hxx"

////
//	*******************************************************************************
//	Get Compile Macro
//	Create	:	2013/03/07
//	Modify	:	2014/01/16	_WIN64 , _AFXDLL
//	Modify	:	2014/12/25	_WINDOWS , _CONSOLE
//	Modify	:	2016/05/09	_MSC_FULL_VER
//	Modify	:	2016/10/19	_DLL
//	Modify	:	2022/08/02	_MSC_VER and _MSC_FULL_VER
//	*******************************************************************************
inline	std::vector<tstring>	Debug_GetMacroCC_v	(void)
{
	std::vector<tstring>	type_ary ;
	#ifdef	_WIN64
		type_ary.push_back(_T("_WIN64 ")) ;
	#elif	_WIN32
		type_ary.push_back(_T("_WIN32 ")) ;
	#endif
	#ifdef	__GNUC__
		type_ary.push_back(_T("__GNUC__ ")) ;
	#endif
	#ifdef	__APPLE_CC__
		type_ary.push_back(_T("__APPLE_CC__ ")) ;
	#endif
	#ifdef	MONODEVELOP
		type_ary.push_back(_T("MONODEVELOP ")) ;
	#endif
	#ifdef	__MACOS_CLASSIC__
		type_ary.push_back(_T("__MACOS_CLASSIC__ ")) ;
	#endif
	#ifdef	TARGET_OS_MAC
		type_ary.push_back(_T("TARGET_OS_MAC ")) ;
	#endif
	#ifdef	TARGET_OS_WIN32
		type_ary.push_back(_T("TARGET_OS_WIN32 ")) ;
	#endif
	#ifdef	_MSC_VER
		type_ary.push_back(_T("_MSC_VER ")		+	::utot(_MSC_VER,		10)+_T(" ")) ;
	#endif
	#ifdef	_MSC_FULL_VER
		type_ary.push_back(_T("_MSC_FULL_VER ")	+	::utot(_MSC_FULL_VER,	10)+_T(" ")) ;
	#endif
	#ifdef	_MFC_VER
		type_ary.push_back(_T("_MFC_VER ")		+	::utot(_MFC_VER,		16)+_T(" ")) ;
	#endif
	#ifdef	_ATL_VER
		type_ary.push_back(_T("_ATL_VER ")		+	::utot(_ATL_VER,		16)+_T(" ")) ;
	#endif
	#ifdef	_UNICODE
		type_ary.push_back(_T("_UNICODE ")) ;
	#endif
	#ifdef	_MBCS
		type_ary.push_back(_T("_MBCS ")) ;
	#endif
	#ifdef	__cplusplus_cli
		type_ary.push_back(_T("__cplusplus_cli ")) ;
	#endif
	#ifdef	__VERSION__
		type_ary.push_back(_T("__VERSION__ ")	__VERSION__	_T(" ")) ;
	#endif
	#ifdef	_AFXDLL
		type_ary.push_back(_T("_AFXDLL ")) ;
	#elif	_DLL
		type_ary.push_back(_T("_DLL ")) ;
	#endif
	#ifdef	_DEBUG
		type_ary.push_back(_T("_DEBUG ")) ;
	#endif
	#ifdef	DEBUG
		type_ary.push_back(_T("DEBUG ")) ;
	#endif
	#ifdef	_WINDOWS
		type_ary.push_back(_T("_WINDOWS ")) ;
	#endif
	#ifdef	_CONSOLE
		type_ary.push_back(_T("_CONSOLE ")) ;
	#endif
	#ifdef	_DOS
		type_ary.push_back(_T("_DOS ")) ;
	#endif
	#ifdef	_OPENMP
		type_ary.push_back(_T("_OPENMP ")) ;
	#endif
	return	type_ary ;
	}

inline	tstring	Debug_GetMacroCC	(void)
{
	std::vector<tstring>	type_ary = Debug_GetMacroCC_v() ;
	return	::String_Join(type_ary) ;
	}

