//	*******************************************************************************
//	Name	:	filefnc.hxx
//			:	File Functions
//	Author	:	I. Nakagawa
//	Create	:	2014/05/20
//	Modify	:	2017/03/02
//	Modify	:	2019/01/22	add Get_unique_name
//	*******************************************************************************

#pragma		once

#include	<ctime>
#include	"filepath.hxx"
#include	"delff_e.hxx"

#ifdef		_WINDOWS_
#include	"FileAttr.hxx"
#endif

////
//	*******************************************************************************
//	Get Latest
//	Create	:	2014/05/20
//	*******************************************************************************
inline	tstring	GetLatestFile	(c_v_tstring& docFiles)
{
	tstring	latest ;
	time_t	m_time = 0 ;
	for (size_t index=0 ; index<docFiles.size() ; index++) {
		tstring	docFile = docFiles[index] ;
		time_t	d_mtime = F_Stat::GetMTime(docFile.c_str()) ;
		if (d_mtime > m_time) {
			m_time = d_mtime ;
			latest = docFile ;
			}
		}
	return	latest ;
	}

////
//	*******************************************************************************
//	remove file
//	Create	:	2016/10/18
//	*******************************************************************************
inline	bool	Remove_File_later	(LPCTSTR fileName,const long days=10)
{
	time_t		now_time = ::time(NULL) ;
	tstring		f__Title = ::Path_GetTitle	(fileName) ;
	tstring		file_ext = ::Path_GetExt	(fileName) ;
	tstring		foldName = ::Path_GetDir	(fileName) ;
	tstring		wildName = f__Title+_T("*.")+file_ext ;
	v_tstring	wc_Files = ::EnumFiles(foldName.c_str(),wildName) ;
	bool		result = true ;
	{
		static	DelFF_E	DFE ;
		for (size_t index=0 ; index<wc_Files.size() ; index++) {
			tstring	wc_Name = wc_Files[index] ;
		//	u_64	wc_size = ::File_GetSize (wc_Name.c_str()) ;
			time_t	wc_time = ::File_GetMTime(wc_Name.c_str()) ;
			#ifdef	_WINDOWS_
			if (::FA_Is_ReadOnly(wc_Name))	{	continue ;	}
			#endif
		//	if (wc_size > 0)				{	continue ;	}
			i_64	time_df = i_64(now_time-wc_time) ;
			if (time_df < days*24*60*60)	{	continue ;	}		//	10 days later
			DFE.Add(wc_Name) ;
			result = false ;
			}
		}
	return	result ;
	}
inline	bool	Remove_File_later	(c_tstring& fileName	,	const long days=10)
{
	return	  ::Remove_File_later	(	fileName.c_str()	,	days) ;
	}

////
//	*******************************************************************************
//	get unique file name
//	Create	:	2019/01/17
//	Modify	:	2019/01/24
//	*******************************************************************************
inline	tstring	Get_unique_name	(c_tstring& fileName,const bool force=false)
{
	tstring	base = ::Path_GetBase(fileName) ;
	tstring	ext  = ::Path_GetExt (fileName) ;
	tstring	uname= fileName ;
	if (!force) {
		if (::File_IsNothing(fileName))	{
			return	uname ;
			}
		}
	for (u_32 index=0 ; index<1000 ; index++) {
		tstring	chk_No_ = ::u32to0t(index,10,3) ;
		tstring	chkName = base + _T(".") + chk_No_ + _T(".") + ext ;
				chkName = base + _T(".") + chk_No_ ;
		if (!ext.empty())	{			   chkName+= _T(".") + ext ;	}
		if (::File_IsNothing(chkName))	{
			uname = chkName ;
			break ;
			}
		}
	return	uname ;
	}

