//	*******************************************************************************
//	Name	:	i_trace.hxx
//			:	Debug Functions
//	Author	:	I. Nakagawa
//	Create	:	2016/04/22
//	Modify	:	2016/10/19
//	Modify	:	2019/12/27
//	Modify	:	2024/11/28	::Get_i_Tools_tmp_name
//	*******************************************************************************

#pragma		once

#include	"itls_tmp.hxx"
#include	"filefnc.hxx"
#include	"openfile.hxx"
#include	"username.hxx"
#include	"str_chg.hxx"
#include	"t_v_char.hxx"

//#ifdef  	_WIN32
//#include	"SH_GetF_.hxx"
//#endif

////
//	*******************************************************************************
//	Trace
//	Create	:	2016/04/22
//	Modify	:	2016/10/18
//	Modify	:	2019/12/27
//	Modify	:	2024/11/28	::Get_i_Tools_tmp_name
//	*******************************************************************************
inline	bool	i_Trace	(const v_char& text)
{
	tstring	path_name ;
	{
		static	bool	ClearYet = true ;
		tstring	md_HStr = ::Now_Format(_T("%m%d_%H")) ;
		#ifdef	_DEBUG
				md_HStr = ::Now_Format(_T("%d_%H%M")) ;
		#endif
		{
			path_name = ::GetTmpPath() ;
			#ifdef	CSIDL_COMMON_DOCUMENTS
			path_name = ::SH_GetFolderPath(CSIDL_COMMON_DOCUMENTS) ;
			path_name = ::Path_AddLastSP(path_name) + _T("Temp") ;
			path_name = ::Path_AddLastSP(path_name) + _T("Temp") ;
			#endif
			path_name = ::Path_AddLastSP(path_name) + _T("DbgDump") ;
			path_name = ::Get_i_Tools_tmp_name       (_T("_trace_")) ;
			path_name = ::Path_AddLastSP(path_name) ;
			if (ClearYet)	{	::Remove_File_later(path_name + _T(".txt")) ;	}
			#if		defined	_UNICODE
			path_name = ::Path_AddLastSP(path_name) + _T("WC") ;
			#elif	defined	_MBCS
			path_name = ::Path_AddLastSP(path_name) + _T("MB") ;
			#endif
			::Folder_Create(path_name) ;
			path_name = ::Path_AddLastSP(path_name) ;
			if (ClearYet)	{	::Remove_File_later(path_name + _T(".txt")) ;	}
			path_name = ::Path_AddLastSP(path_name) + md_HStr + _T(".txt") ;
			}
		ClearYet = false ;
		}
	FILE*	ofp = ::Open_File(path_name.c_str(),_T("ab")) ;
	if (ofp == NULL)	{
	//	::Log_Message((tstring(_T("Can't open ab  "))+path_name).c_str()) ;
		tstring	msg = 		   _T("Can't open ab  ") +path_name ;
		#ifdef	_DEBUG
			#ifdef	_MFC_VER
				afxDump		<< msg.c_str() << _T("\r\n") ;
			#else
				std::terr	<< msg         << std::endl ;
			#endif
		#endif
		return	false ;
		}
	{
		size_t	fSize = size_t(F_Stat::GetSize(path_name.c_str())) ;
		if (fSize == 0) {
			#ifdef	_UNICODE
			{
				#define	UTF16_BOM	("\xff\xfe")
				v_char	bom = ::To_v_char(UTF16_BOM) ;
				::fwrite(&bom[0],sizeof(char),bom.size(),ofp) ;
				}
			#endif
			#ifdef	_WIN32
			#ifdef	_DEBUG
			{
				::MessageBeep(-1) ;
				}
			#endif
			#endif
			#ifdef	_WIN32
			{
				tstring	userName = ::Get_user_name  ()			+	_T("\r\n") ;
				tstring	temp_Dir = ::GetTmpPath     ()			+	_T("\r\n") ;
				tstring	currentD = ::GetCWD         ()			+	_T("\r\n") ;
				tstring	exe_name = ::Get_module_name()			+	_T("\r\n") ;
				tstring	writeStr = userName + temp_Dir + currentD + exe_name ;
				tstring	tStr = ::String_CrLfToSP(writeStr,_T("\t\t")) ;
						tStr = ::Now_Format() + _T("\t") + tStr	+	_T("\r\n") ;
				v_char	v_chr = ::To_v_char(tStr) ;
				::fwrite(&v_chr[0],sizeof(char),v_chr.size(),ofp) ;
				}
			#endif
			}
		}
	if (text.size() > 0) {
		::fwrite(&text[0],sizeof(char),text.size(),ofp) ;
		}
	::fclose(ofp) ;
	return	true ;
	}

////
//	*******************************************************************************
//	Trace	tstring
//	Create	:	2016/04/22
//	Modify	:	2016/10/19	use String_CrLfToSP
//	*******************************************************************************
inline	bool	i_Trace	(const tstring& tStr_)
{
//	tstring	tStr = tStr_ ;
	tstring	tStr = ::String_CrLfToSP(tStr_,_T("\t\t")) ;
	tstring	exe_Name ;
	#ifdef	_WIN32
			exe_Name = ::Path_GetName(::Get_module_name())		+	_T("\t") ;
	#endif
//	if (tStr.empty())	{	return	false ;		}
	{
		tStr = ::Now_Format() + _T("\t")	+	exe_Name	+ tStr + _T("\r\n") ;
		}
	v_char	v_chr = ::To_v_char(tStr) ;
	return	::i_Trace(v_chr) ;
	}






//#include	"stringfn.hxx"
//#include	"createff.hxx"
