//	*******************************************************************************
//	Name	:	itls_tmp.hxx
//			:	%TEMP%/i_Tools.tmp/exe_title/
//	Author	:	I. Nakagawa
//	Create	:	2016/06/16
//	Modify	:	2016/06/30	Add "Clear_..."
//	Modify	:	2018/02/28	Add "Get_convert_..."
//	Modify	:	2021/07/06	::Get_module_name
//	Modify	:	2022/08/05	::Get_Self_Original
//	Modify	:	2022/08/05	::Get_i_Tools_tmp_name
//	Modify	:	2024/04/17	"24 04 17"
//	Modify	:	2024/11/22	
//	*******************************************************************************

#pragma		once

#include	"get_path.hxx"
#include	"createff.hxx"
#include	"timefmt.hxx"

//#include	"i_trace.hxx"
//#include	"log_msg.hxx"

#ifdef	_WIN32
#include	"FVersion.hxx"
#include	"SH_GetF_.hxx"
#endif

#ifdef	_DEBUG
	#define	ITT_YMD	_T("%y %m %d")	//	"24 04 17"
#else
	#define	ITT_YMD	_T("%Y%m%d")	//	"20240417"
#endif

////
//	*******************************************************************************
//	%TEMP%/i_Tools.tmp/name/...
//	Create	:	2022/08/05
//	*******************************************************************************
inline	tstring	Get_i_Tools_tmp_name		(LPCTSTR name)
{
	tstring	tmp_path = ::GetTmpPath() ;
			tmp_path = ::Path_AddLastSP(tmp_path) + _T("i_Tools.tmp") ;
			tmp_path = ::Path_AddLastSP(tmp_path) + name ;
	::Folder_Create(tmp_path) ;
	return	tmp_path ;
	}

inline	tstring	Get_i_Tools_tmp_name_date	(LPCTSTR name)
{
	tstring	tmp_path = ::Get_i_Tools_tmp_name(name) ;
			tmp_path = ::Path_AddLastSP(tmp_path) + ::Now_Format(ITT_YMD) ;
	::Folder_Create(tmp_path) ;
	return	tmp_path ;
	}

////
//	*******************************************************************************
//	%TEMP%/i_Tools.tmp/exe_title/
//	Create	:	2016/06/30
//	Modify	:	2017/03/22	support not _WIN32
//	Modify	:	2021/07/06	::Get_module_name
//	Modify	:	2022/08/05	::Get_Self_Original
//	*******************************************************************************
inline	tstring	Get_i_Tools_tmp_Path	(void)
{
	tstring	exe_title ;
			exe_title = ::Now_Format(ITT_YMD) ;
	{
		tstring	mod_name = ::Get_module_name() ;
		tstring	exe_name = ::Path_GetName(mod_name) ;
		#ifdef	_WIN32
		tstring	org_name = ::Get_Self_Original() ;
		if (!org_name.empty()) {
			if (!::String_CompareNoCase(exe_name,org_name)) {
				exe_name = org_name ;
				}
			}
		#endif
		if (!exe_name.empty()) {
			exe_title = ::Path_GetTitle(exe_name) ;
			}
		}
	tstring	tmp_path = ::Path_AddLastSP(::GetTmpPath())	+ _T("i_Tools.tmp") ;
			tmp_path = ::Path_AddLastSP(tmp_path)		+ exe_title ;
			tmp_path = ::Path_AddLastSP(tmp_path) ;
	return	tmp_path ;
	}

////
//	*******************************************************************************
//	%TEMP%/i_Tools.tmp/exe_title/
//	Create	:	2016/06/16
//	Modify	:	2017/03/03
//	*******************************************************************************
inline	tstring	Get_i_Tools_tmp	(void)
{
	tstring	tmp_path = ::Get_i_Tools_tmp_Path() ;
	if (!::Folder_Create(tmp_path)) {
		#ifdef	CSIDL_COMMON_DOCUMENTS
		{
			tstring	exe_title = ::Path_GetTitle(::Get_module_name()) ;
			tmp_path = ::SH_GetFolderPath(CSIDL_COMMON_DOCUMENTS) ;
			tmp_path = ::Path_AddLastSP(tmp_path) + _T("Temp") ;
			tmp_path = ::Path_AddLastSP(tmp_path) + _T("Temp") ;
			tmp_path = ::Path_AddLastSP(tmp_path) + _T("i_Tools.tmp") ;
			tmp_path = ::Path_AddLastSP(tmp_path) + exe_title ;
		//	::i_Trace(tmp_path) ;
			::i_Dump (tmp_path) ;
			}
		#else
		{
		//	::i_Trace(_T("can not write.  ")+tmp_path) ;
			::i_Dump (_T("can not write.  ")+tmp_path) ;
			tmp_path = ::GetTmpPath() ;
		//	::Log_Message(tmp_path.c_str()) ;
			}
		#endif
		}
			tmp_path = ::Path_AddLastSP(tmp_path) ;
	return	tmp_path ;
	}

////
//	*******************************************************************************
//	%TEMP%/i_Tools.tmp/exe_title/date/
//	Create	:	2017/03/31
//	*******************************************************************************
inline	tstring	Get_i_Tools_tmp_date	(void)
{
	tstring	date_str = ::Now_Format(ITT_YMD) ;
	tstring	tmp_path = ::Get_i_Tools_tmp() ;
			tmp_path = ::Path_AddLastSP(tmp_path) + date_str ;
	if (!::Folder_Create(tmp_path)) {
			tmp_path = ::Get_i_Tools_tmp() ;
		}
			tmp_path = ::Path_AddLastSP(tmp_path) ;
	return	tmp_path ;
	}

