//	*******************************************************************************
//	Name	:	str_trim.hxx
//			:	string trim
//	Author	:	I. Nakagawa
//	Create	:	2024/11/25
//	Modify	:	2013/03/12
//	Modify	:	2015/07/07	Add String_TrimBoth
//			:	2020/02/07	Add String_TrimSpace
//			:	2024/11/25
//	*******************************************************************************

#pragma		once

#include	"tstring.hxx"

////
//	*******************************************************************************
//	Trim Right
//	Create	:	2013/03/12
//	*******************************************************************************
inline	tstring	String_TrimRight	(c_tstring& str_,const TCHAR tc=_T('\0'))
{
	tstring	str = str_ ;
	{
		int		startIndex = -1 ;
		for (size_t index=0 ; index<str.length() ; index++) {
			TCHAR	ch = str[index] ;
			#ifdef	_MBCS
			{
				if (_ismbblead(ch))	{	startIndex=-1 ;	index++ ;	continue ;	}
				}
			#endif
			bool	isTrimChar = false ;
			if		(tc==_T('\0') && _istspace(ch))	{	isTrimChar = true ;			}
			else if (tc == ch)						{	isTrimChar = true ;			}
			else									{	startIndex = -1 ;			}
			if (startIndex < 0 && isTrimChar)		{	startIndex = int(index) ;	}
			}
		if (0 <= startIndex)	{
			str = str.substr(0,startIndex) ;
			}
		}
	return	str ;
	}

////
//	*******************************************************************************
//	Trim Left
//	Create	:	2013/03/12
//	*******************************************************************************
inline	tstring	String_TrimLeft	(c_tstring& str_,const TCHAR tc=_T('\0'))
{
	tstring	str = str_ ;
	{
		int		otherIndex = -1 ;
		bool	isOnlySP = true ;
		for (size_t index=0 ; index<str.length() ; index++) {
			TCHAR	ch = str[index] ;
			if		(tc==_T('\0') && _istspace(ch))	{	;	}
			else if (tc == ch)						{	;	}
			else									{
				otherIndex = int(index) ;
				isOnlySP = false ;
				break ;
				}
			}
		if (0 <= otherIndex)	{
			str = str.substr(otherIndex) ;
			}
		else if (isOnlySP) {
			str.erase() ;
			}
		}
	return	str ;
	}

////
//	*******************************************************************************
//	Trim Left and Right
//	Create	:	2015/07/08
//	*******************************************************************************
inline	tstring	String_TrimBoth	(c_tstring& str_,const TCHAR tc=_T('\0'))
{
	tstring	str = str_ ;
			str = ::String_TrimLeft	(str) ;
			str = ::String_TrimRight(str) ;
	return	str ;
	}

////
//	*******************************************************************************
//	Trim Space
//	Create	:	2020/02/07
//	*******************************************************************************
inline	tstring	String_TrimSpace	(c_tstring& str_)
{
	tstring		str ;
	{
		tstring	tmp = ::String_TrimBoth(str_) ;
		for (size_t index=0 ; index<tmp.length() ; index++) {
			tstring	c ;
			if		(_istlead (tmp[index]))	{	c = tmp.substr(index,2) ;	index++ ;	}
			else if	(_istspace(tmp[index]))	{	;										}
			else							{	c = tmp[index] ;						}
			str += c ;
			}
		}
	return	str ;
	}

