//	*******************************************************************************
//	Name	:	stringto.hxx
//			:	vector<tstring>	Functions
//	Author	:	I. Nakagawa
//	Create	:	2014/01/15
//	Modify	:	2014/01/15
//	Modify	:	2014/06/11	Move String_SplitLine_CSV
//	Modify	:	2014/09/05	String_SplitLine	Add isLine flag
//	Modify	:	2024/11/12
//	*******************************************************************************

#pragma		once

#include	"strary_f.hxx"
#include	"str_splt.hxx"
#include	"str_join.hxx"

////
//	*******************************************************************************
//	StringArry -> String
//	Create	:	2014/01/22
//	Modify	:	2014/01/23	Add "CRLF" Last Line
//	*******************************************************************************
inline	tstring	String_Join_Line	(c_v_tstring strAry)
{
	return	::String_Join(strAry,_T("\r\n")) + _T("\r\n") ;
	}

////
//	*******************************************************************************
//	String -> StringArray	Skip Empty
//	Create	:	2013/12/24
//	*******************************************************************************
inline	v_tstring	String_SplitSpace	(LPCTSTR strL,LPCTSTR sp=_T(" \t\r\n"))
{
	tstring		str = strL ;
	v_tstring	strAry ;
	if (!str.empty())	{
		strAry = ::String_Split(str,false,sp) ;
		strAry = ::SkipEmpty(strAry) ;
		}
	return	strAry ;
	}

////
//	*******************************************************************************
//	String -> StringArray	true : "CRLF"	false :	"CR" or "LF"
//	Create	:	2014/01/15
//	Modify	:	2014/09/05	Add isLine flag
//	*******************************************************************************
//	inline	v_tstring	String_SplitLine	(LPCTSTR strL)
	inline	v_tstring	String_SplitLine	(LPCTSTR strL,const bool isLine=true)
{
	tstring		str = strL ;
	v_tstring	strAry ;
	if (!str.empty())	{
		strAry = ::String_Split(str,isLine,_T("\r\n")) ;
		}
	return	strAry ;
	}

////
//	*******************************************************************************
//	Split Line	Character-SV
//	Create	:	2014/05/30
//	*******************************************************************************
//	http://ja.wikipedia.org/wiki/Comma-Separated_Values
//	http://www.kasai.fm/wiki/rfc4180jp
inline	v_tstring	String_SplitLine_CSV(LPCTSTR str)
{
	tstring		tmp = str ;
	tstring		line ;
	bool		in2Quot	= false ;
	bool		in1Quot	= false ;
	bool		isEndL	= false ;
	v_tstring	strAry ;
	for (size_t index=0 ; index<tmp.length() ; index++) {
		tstring	c1 = tmp.substr(index,1) ;
		tstring	c2 = tmp.substr(index,2) ;
		tstring	c  = c1 ;
		if (!in2Quot && !in1Quot) {		//	out of "---"
			if		(c1 == _T("\""))	{	in2Quot = true ;		}
			else if	(c1 == _T("\'"))	{	in1Quot = true ;		}
			else if	(c2 == _T("\r\n"))	{	c = c2 ;	index++ ;
											c.erase() ;
											isEndL = true ;			}
			else if	(c1 == _T("\r"))	{	c = c1 ;
											c.erase() ;
											isEndL = true ;			}
			else if	(c1 == _T("\n"))	{	c = c1 ;
											c.erase() ;
											isEndL = true ;			}
			}
		else if (in2Quot) {				//	"---"
			if (c1 == _T("\""))			{	in2Quot = false ;		}
			}
		else if (in1Quot) {				//	'---'
			if (c1 == _T("\'"))			{	in1Quot = false ;		}
			}
		line += c ;
		if (isEndL) {
			strAry.push_back(line) ;
			line.erase() ;
			isEndL = false ;
			}
		}
	if (!line.empty()) {
		strAry.push_back(line) ;
		}
	return	strAry ;
	}
