//	*******************************************************************************
//	Name	:	textf_sv.hxx
//			:	Text File Access
//	Author	:	I. Nakagawa
//	Create	:	2024/11/22
//	Modify	:	2014/02/13
//			:	2014/05/01
//			:	2020/01/24	
//	*******************************************************************************

#pragma		once

#include	"wstr_bom.hxx"
#include	"vchrfile.hxx"
#include	"t_v_char.hxx"
#include	"stringto.hxx"

////
//	*******************************************************************************
//	Save Text	tstring
//	Create	:	2014/05/07
//	*******************************************************************************
inline	bool	SaveText		(LPCTSTR path_name,const tstring& tstr_)
{
	tstring	tstr = tstr_ ;
	#ifdef	_UNICODE
			tstr = ::WString_Add_BOM(tstr) ;
	#endif
	v_char	v_chr = ::To_v_char(tstr) ;
	return	::v_c_Save(path_name,v_chr) ;
	}

////
//	*******************************************************************************
//	Save Text	vector<tstring>
//	Create	:	2014/05/01
//	Modify	:	2014/05/07
//	Modify	:	2020/01/24
//	*******************************************************************************
inline	bool	SaveText		(LPCTSTR path_name,const v_tstring& vtstr)
{
	tstring	tstr ;
	if (vtstr.size() > 0) {	//	2020/01/24
			tstr = ::String_Join_Line(vtstr) ;
		}
	return	::SaveText(path_name,tstr) ;
	}

inline	bool	SaveTextFile	(LPCTSTR path_name,const v_tstring& vtstr)
{
	return	::SaveText(path_name,vtstr) ;
	}

